#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <pthread.h>

#define DEVNODE "/dev/cdev_test"
#define MAX_THREAD 8

void *
cdev_openclose_thread(void *arg)
{
	int max = *(int *)arg;
	int i, succeed, fail, fd;


	for (i = 0; i < max; i++) {
		fd = open(DEVNODE, O_RDWR);
		if (fd == -1) {
			fail++;
			if (errno != EBUSY) {
				perror("Unexpected error");
				exit(1);
			}
		} else {
			close(fd);
			succeed++;
		}
	}
	printf("opened %d, busy %d\n", succeed, fail);
}

int
main(int argc, char *argv[])
{
	int max, i, err, thread_cnt = 1;
	pthread_t threads[MAX_THREAD];

	if (argc < 2)
		max = 1;
	else
		max = atoi(argv[1]);
	if (argc == 3)
		thread_cnt = atoi(argv[2]);
	if (thread_cnt > MAX_THREAD)
		thread_cnt = MAX_THREAD;

	printf("starting %d threads\n", thread_cnt);
	for (i = 0; i < thread_cnt; i++) {
		err = pthread_create(&threads[i], NULL, cdev_openclose_thread,
				     (void *)&max);
		if (err != 0) {
			perror("pthread_create");
			exit(2);
		}
	}
	for (i = 0; i < thread_cnt; i++)
		pthread_join(threads[i], NULL);
	return (0);
}
